"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.initialState = void 0;
const actions_1 = require("./actions");
exports.initialState = {
    answers: [],
    answerInputs: {},
    isLastAnswer: false,
    isQuizCompleted: false,
};
function answerInputReducer(state, action) {
    return Object.assign(Object.assign({}, state), { [String(action.payload.questionId)]: {
            type: action.type,
            value: action.payload.input,
        } });
}
function quizLocalReducer(state, action) {
    var _a, _b, _c, _d, _e;
    switch (action.type) {
        case actions_1.QuestionTypes.OpenText:
            return Object.assign(Object.assign({}, state), { answerInputs: answerInputReducer(state.answerInputs, action), isLastAnswer: !!((_a = action.payload) === null || _a === void 0 ? void 0 : _a.isLastQuestion), isQuizCompleted: false });
        case actions_1.QuestionTypes.Cover:
            return Object.assign(Object.assign({}, state), { answerInputs: answerInputReducer(state.answerInputs, action), isLastAnswer: !!((_b = action.payload) === null || _b === void 0 ? void 0 : _b.isLastQuestion), isQuizCompleted: false });
        case actions_1.QuestionTypes.SingleSelect:
            return Object.assign(Object.assign({}, state), { answerInputs: answerInputReducer(state.answerInputs, action), isLastAnswer: !!((_c = action.payload) === null || _c === void 0 ? void 0 : _c.isLastQuestion), isQuizCompleted: false });
        case actions_1.QuestionTypes.MultipleSelect:
            return Object.assign(Object.assign({}, state), { answerInputs: answerInputReducer(state.answerInputs, action), isLastAnswer: !!((_d = action.payload) === null || _d === void 0 ? void 0 : _d.isLastQuestion), isQuizCompleted: false });
        case actions_1.QuestionTypes.Next: {
            const { answers } = state;
            const newAnswers = [...answers];
            const lastAnswerInputIndex = answers.length;
            const currentAnswerInput = (_e = Object.values(state.answerInputs)) === null || _e === void 0 ? void 0 : _e[lastAnswerInputIndex];
            switch (currentAnswerInput.type) {
                case actions_1.QuestionTypes.OpenText:
                    newAnswers.push(['true']);
                    break;
                case actions_1.QuestionTypes.Cover:
                    newAnswers.push(['seen']);
                    break;
                case actions_1.QuestionTypes.SingleSelect:
                    newAnswers.push(currentAnswerInput.value);
                    break;
                case actions_1.QuestionTypes.MultipleSelect:
                    newAnswers.push(currentAnswerInput.value);
                    break;
                default:
                    newAnswers.push([]);
            }
            return Object.assign(Object.assign({}, state), { answers: newAnswers, isQuizCompleted: false });
        }
        case actions_1.QuestionTypes.Back: {
            const newAnswerInputs = Object.assign({}, state.answerInputs);
            return Object.assign(Object.assign({}, state), { answerInputs: newAnswerInputs, answers: [...state.answers.slice(0, -1)], isLastAnswer: false, isQuizCompleted: false });
        }
        case actions_1.QuestionTypes.Reset:
            return Object.assign({}, exports.initialState);
        case actions_1.QuestionTypes.Hydrate:
            return Object.assign(Object.assign({}, state), action.payload);
        case actions_1.QuestionTypes.Complete:
            return Object.assign(Object.assign({}, state), { isQuizCompleted: true });
        default:
            return state;
    }
}
exports.default = quizLocalReducer;
