"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const ResultCtaButton_1 = tslib_1.__importDefault(require("../ResultCtaButton/ResultCtaButton"));
const context_1 = tslib_1.__importDefault(require("../CioQuiz/context"));
function ResultCard(props) {
    var _a, _b, _c, _d;
    const { result, salePriceKey, regularPriceKey, resultPosition, ratingCountKey, ratingScoreKey, renderResultCardPriceDetails, } = props;
    const { customClickItemCallback, getQuizResultButtonProps, getQuizResultLinkProps } = (0, react_1.useContext)(context_1.default);
    const salePrice = salePriceKey && ((_a = result === null || result === void 0 ? void 0 : result.data) === null || _a === void 0 ? void 0 : _a[salePriceKey]);
    const regularPrice = regularPriceKey && ((_b = result === null || result === void 0 ? void 0 : result.data) === null || _b === void 0 ? void 0 : _b[regularPriceKey]);
    const ratingCount = ratingCountKey && ((_c = result === null || result === void 0 ? void 0 : result.data) === null || _c === void 0 ? void 0 : _c[ratingCountKey]);
    const ratingScore = ratingScoreKey && ((_d = result === null || result === void 0 ? void 0 : result.data) === null || _d === void 0 ? void 0 : _d[ratingScoreKey]);
    const resultCardContent = () => {
        var _a;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("div", { className: 'cio-result-card-image' },
                react_1.default.createElement("img", { src: (_a = result.data) === null || _a === void 0 ? void 0 : _a.image_url, alt: 'product' })),
            react_1.default.createElement("div", { className: 'cio-result-card-text' },
                react_1.default.createElement("p", { className: 'cio-result-card-title' }, result.value),
                react_1.default.createElement("div", { className: 'cio-result-card-details' },
                    react_1.default.createElement("div", { className: 'cio-result-card-rating' },
                        ratingScore && (react_1.default.createElement("span", { className: 'cio-result-card-rating-score' },
                            Array(Number(ratingScore)).fill('★'),
                            Array(5 - Number(ratingScore)).fill('☆'))),
                        ratingCount && react_1.default.createElement("span", { className: 'cio-result-card-rating-count' },
                            "(",
                            ratingCount,
                            ")")),
                    renderResultCardPriceDetails ? (renderResultCardPriceDetails(result)) : (react_1.default.createElement("div", { className: 'cio-result-card-prices' },
                        salePrice && react_1.default.createElement("span", { className: 'cio-result-card-sale-price' },
                            "$",
                            salePrice),
                        regularPrice && (react_1.default.createElement("span", { className: `cio-result-card-regular-price${salePrice ? '--strike-through' : ''}` },
                            "$",
                            regularPrice))))))));
    };
    const resultCardContentWithoutLink = () => getQuizResultButtonProps && (react_1.default.createElement("div", Object.assign({}, getQuizResultButtonProps({ result, position: resultPosition, type: 'button' })), resultCardContent()));
    const resultCardContentWithLink = () => getQuizResultLinkProps && (react_1.default.createElement("a", Object.assign({ className: 'cio-result-card-anchor', rel: 'noreferrer', target: '_blank' }, getQuizResultLinkProps({ result, position: resultPosition, type: 'link' })), resultCardContent()));
    return (react_1.default.createElement("div", { className: 'cio-result-card' },
        !customClickItemCallback ? resultCardContentWithLink() : resultCardContentWithoutLink(),
        react_1.default.createElement(ResultCtaButton_1.default, { item: result, price: salePrice || regularPrice })));
}
exports.default = ResultCard;
