"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
function useNextQuestionButtonProps(nextQuestion, quizApiState, quizLocalState) {
    const getNextQuestionButtonProps = (0, react_1.useCallback)(() => {
        var _a, _b, _c, _d, _e;
        const currentQuestionId = (_a = quizApiState.quizCurrentQuestion) === null || _a === void 0 ? void 0 : _a.next_question.id;
        let buttonDisabled;
        if (currentQuestionId && !((_b = quizApiState.quizCurrentQuestion) === null || _b === void 0 ? void 0 : _b.isCoverQuestion)) {
            buttonDisabled =
                !((_c = quizLocalState.answerInputs[currentQuestionId]) === null || _c === void 0 ? void 0 : _c.value) ||
                    !((_e = (_d = quizLocalState.answerInputs[currentQuestionId]) === null || _d === void 0 ? void 0 : _d.value) === null || _e === void 0 ? void 0 : _e.length);
        }
        return {
            className: buttonDisabled ? 'cio-question-cta-button disabled' : 'cio-question-cta-button',
            type: 'button',
            onClick: () => {
                nextQuestion();
            },
        };
    }, [quizApiState.quizCurrentQuestion, quizLocalState.answerInputs, nextQuestion]);
    return getNextQuestionButtonProps;
}
exports.default = useNextQuestionButtonProps;
