"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const useQuizApiState_1 = tslib_1.__importDefault(require("./useQuizApiState"));
const useQuizLocalState_1 = tslib_1.__importDefault(require("./useQuizLocalState"));
const useQuizState = (quizOptions, cioClient) => {
    const { sessionStateOptions } = quizOptions;
    // Quiz Local state
    const { quizLocalState, dispatchLocalState, hasQuizStoredState, skipToResults, quizStateKey } = (0, useQuizLocalState_1.default)(sessionStateOptions);
    // Quiz API state
    const { quizApiState, dispatchApiState } = (0, useQuizApiState_1.default)(quizOptions, cioClient, quizLocalState, skipToResults, dispatchLocalState);
    return {
        quizApiState,
        quizLocalState,
        dispatchApiState,
        dispatchLocalState,
        hasQuizStoredState,
        skipToResults,
        quizStateKey,
    };
};
exports.default = useQuizState;
