import React, { useContext } from 'react';
import RedoButton from '../RedoButton/RedoButton';
import QuizContext from '../CioQuiz/context';
import ResultFilters from '../ResultFilters/ResultFilters';
import ZeroResults from '../ZeroResults/ZeroResults';
import Results from '../Results/Results';
import Spinner from '../Spinner/Spinner';
export default function ResultContainer(props) {
    const { options } = props;
    const { resultCardSalePriceKey, resultCardRegularPriceKey, resultCardRatingCountKey, resultCardRatingScoreKey, renderResultCardPriceDetails, } = options;
    const { state } = useContext(QuizContext);
    const zeroResults = !state?.quiz.results?.response?.results?.length;
    const resultsTitle = zeroResults ? '' : 'Here are your results';
    if (state?.quiz.results) {
        return (React.createElement("div", { className: 'cio-results-container' },
            React.createElement("h1", { className: 'cio-results-title' }, resultsTitle),
            React.createElement("div", { className: 'cio-results-filter-and-redo-container' },
                React.createElement(ResultFilters, { hasNoResults: zeroResults }),
                React.createElement(RedoButton, null)),
            !zeroResults && (React.createElement(Results, { resultCardSalePriceKey: resultCardSalePriceKey, resultCardRegularPriceKey: resultCardRegularPriceKey, resultCardRatingCountKey: resultCardRatingCountKey, resultCardRatingScoreKey: resultCardRatingScoreKey, renderResultCardPriceDetails: renderResultCardPriceDetails })),
            zeroResults && React.createElement(ZeroResults, null)));
    }
    return (React.createElement("div", { className: 'cio-results-container' },
        React.createElement(Spinner, null)));
}
