import { useCallback } from 'react';
export default function useNextQuestionButtonProps(nextQuestion, quizApiState, quizLocalState) {
    const getNextQuestionButtonProps = useCallback(() => {
        const currentQuestionId = quizApiState.quizCurrentQuestion?.next_question.id;
        let buttonDisabled;
        if (currentQuestionId && !quizApiState.quizCurrentQuestion?.isCoverQuestion) {
            buttonDisabled =
                !quizLocalState.answerInputs[currentQuestionId]?.value ||
                    !quizLocalState.answerInputs[currentQuestionId]?.value?.length;
        }
        return {
            className: buttonDisabled ? 'cio-question-cta-button disabled' : 'cio-question-cta-button',
            type: 'button',
            onClick: () => {
                nextQuestion();
            },
        };
    }, [quizApiState.quizCurrentQuestion, quizLocalState.answerInputs, nextQuestion]);
    return getNextQuestionButtonProps;
}
