import useQuizApiState from './useQuizApiState';
import useQuizLocalState from './useQuizLocalState';
const useQuizState = (quizOptions, cioClient) => {
    const { sessionStateOptions } = quizOptions;
    // Quiz Local state
    const { quizLocalState, dispatchLocalState, hasQuizStoredState, skipToResults, quizStateKey } = useQuizLocalState(sessionStateOptions);
    // Quiz API state
    const { quizApiState, dispatchApiState } = useQuizApiState(quizOptions, cioClient, quizLocalState, skipToResults, dispatchLocalState);
    return {
        quizApiState,
        quizLocalState,
        dispatchApiState,
        dispatchLocalState,
        hasQuizStoredState,
        skipToResults,
        quizStateKey,
    };
};
export default useQuizState;
